module numbertheory

  implicit none

  private gcd9, lcm9, gcd18, lcm18 

  interface gcd 
    module procedure gcd9, gcd18 
  end interface 

  interface lcm 
    module procedure lcm9, lcm18 
  end interface 

contains

  function gcd9(a, b) ! Greatest Common Divisor
    integer(selected_int_kind(9)) :: gcd9
    integer(selected_int_kind(9)), intent(in) :: a, b
    integer(selected_int_kind(9)) :: gb, t

    gcd9 = abs(a)
    gb = abs(b)

    if (a == 0) gcd9 = gb 
    if (a == 0 .or. b == 0) return 

    do
      t = mod(gcd9, gb)
      gcd9 = gb
      if (t == 0) exit
      gb = t
    end do

  end function gcd9

  function lcm9(a, b) ! Least Common Multiple
    integer(selected_int_kind(9)) :: lcm9
    integer(selected_int_kind(9)), intent(in) :: a, b

    if (a == 0 .and. b == 0) then 
      lcm9 = 0 ; return 
    end if 

    lcm9 = a*(b/gcd9(a,b))

  end function lcm9

  function gcd18(a, b) ! Greatest Common Divisor
    integer(selected_int_kind(18)) :: gcd18
    integer(selected_int_kind(18)), intent(in) :: a, b
    integer(selected_int_kind(18)) :: gb, t

    gcd18 = abs(a)
    gb = abs(b)

    if (a == 0) gcd18 = gb 
    if (a == 0 .or. b == 0) return 

    do
      t = mod(gcd18, gb)
      gcd18 = gb
      if (t == 0) exit
      gb = t
    end do

  end function gcd18

  function lcm18(a, b) ! Least Common Multiple
    integer(selected_int_kind(18)) :: lcm18
    integer(selected_int_kind(18)), intent(in) :: a, b

    if (a == 0 .and. b == 0) then 
      lcm18 = 0 ; return 
    end if 

    lcm18 = a*(b/gcd18(a,b))

  end function lcm18

end module numbertheory
