program test_integral
    use integrals
    implicit none

    real, parameter :: pi = acos(-1.0)
    real :: g, x
    intrinsic :: sin

    interface
        real function gauss(x)
        implicit none
        real, intent(in) :: x
        end function gauss
    end interface 

    g = trap_int(0., pi, sin, 0.0000001)
    print *, 'Integral of sin(x) in (0, pi) = ', g
    
    x = 10000.0 ! integral of e^(-x^2) from 0 to infinity is sqrt(pi)/2
    g = trap_int(0., x, gauss, 0.0000001)
    print *, 'Integral of exp(-x^2) in (0, ', x, ') = ', g
end program test_integral 

real function gauss(x)
    implicit none
    real, intent(in) :: x
    gauss = exp(-x**2)
end function gauss
