program histogram
implicit none

integer, parameter :: nbins = 20
integer :: i, niter, ind
real :: hist(nbins)
real :: x, total, width

write(*,*) 'Enter number of samples'
read(*,*) niter
if (niter <= 0) then
   write(0,*) 'number of samples must bepositive'
   stop
endif

hist = 0.
total = 0.
width = 10./nbins

do i=1,niter
   call random_number(x) ! 0 <= x < 1 
   x = 10.*x 
   ind = ceiling(x/width)
   hist(ind) = hist(ind) + 1
   total = total + x
enddo

hist = hist/niter

write(*,*) 'value    hist'
do i=1,20
   write(*,'(f6.2,f12.9)') i*width, hist(i)
enddo
write(*,*) 'total : ',total/niter

end program histogram
