program golden_ratio
! experiments with the golden ratio iterative relation
  implicit none
  integer, parameter :: rk = kind(1.0d0)
  real(rk) :: phi, phi_old
  real(rk) :: phi_start, tol
  integer :: i, max_iter
  
  write(*,*) 'Enter start value, tol, max iterations'
  read(*,*) phi_start, tol, max_iter

  phi_old = phi_start
  do i=1,max_iter
    phi = 1.0d0/phi_old + 1.0d0
    if (abs(phi - phi_old) < tol) exit
    phi_old = phi
  end do

  write(*,100) 'Start value:',phi_start
  write(*,100) 'Tolerance:',tol
  write(*,'(2(A," ",I11,"  "))') 'Ended at iteration:', i, 'of', max_iter
  write(*,100) 'Final value:',phi

100 format(A," ",F13.10)
end program golden_ratio
