program iterative_inversion
! experiments with matrix iterative inversion
  implicit none
  real, dimension(4,4) :: a, x, x_old, x_start
  real :: tol, err
  integer :: i, max_iter
  
  write(*,*) 'Enter 4x4 matrix to invert'
  read(*,*) a
  write(*,*) 'Enter 4x4 start matrix'
  read(*,*) x_start
  write(*,*) 'Enter tol, max iterations'
  read(*,*) tol, max_iter

  x_old = x_start
  do i=1,max_iter
    x = 2.0*x_old - matmul(x_old,matmul(a,x_old))
    err = maxval(abs(x - x_old))
    if (err < tol) exit
    x_old = x
  end do

  write(*,'("Matrix to invert:")')
  write(*,100) a
  write(*,'(/,"Start matrix:")')
  write(*,100) x_start
  write(*,'(/,A," ",E15.7)') 'Tolerance:',tol
  write(*,'(/,2(A," ",I11,"  "))') 'Ended at iteration:', i, 'of', max_iter
  write(*,'("Final matrix:")')
  write(*,100) x

100 format(4(E15.7," "))
end program iterative_inversion
